<template>
  <div class="contSecc">
    <div class="titulo">
      <link
        rel="stylesheet"
        href="https://stackpath.bootstrapcdn.com/bootstrap/4.5.0/css/bootstrap.min.css"
        integrity="sha384-9aIt2nRpC12Uk9gS9baDl411NQApFmC26EwAOH8WgZl5MYYxFfc+NcPb1dKGj7Sk"
        crossorigin="anonymous"
      />
      <div class="ruta">
        <v-breadcrumbs :items="breadcrumbs" :large="false">
          <template v-slot:divider>
            <v-icon>mdi-chevron-right</v-icon>
          </template>
        </v-breadcrumbs>
      </div>
      <strong>Detalle Semana Supervisor</strong>
    </div>

    <div class="cotm">
      <div class="tmod">
        <strong>Detalle Semana Supervisor - {{ this.lblUsuario }}</strong>
      </div>
    </div>

    <div class="contSecc">
      <div class="titSecCard"></div>

      <!-- Sección de fecha búsqueda -->

      <!-- Termina sección fecha búsqueda-->

      <div class="gris">
        <div class="contSecc">
          <div class="divBuscador">
            <div class="padding">
              <v-text-field
                v-model="search"
                class="buscador"
                append-icon="mdi-magnify"
                label="Buscar..."
                clearable
                single-line
                hide-details
              ></v-text-field>
            </div>
          </div>

          <!--  tabla-->
          <v-data-table
            :headers="encabezadoAsignacion"
            :items="asignaciones"
            :page.sync="page"
            :items-per-page="itemsPerPage"
            @page-count="pageCount = $event"
            :search="search"
            class="tblGeneral tblReporte"
          >
            <template v-slot:item.fechaFormated="{ item }">{{
              (item.fechaFormated = formateaFecha(item.fecha))
            }}</template>

            <template v-slot:item.lnkDetalle_="{ item }">
              <a :href="getLinkToDetalle(item)">Detalle</a>
            </template>
          </v-data-table>
        </div>
      </div>

      <div style="margin: 25px 10px 50px 10px">
        <v-btn
          color="primary"
          dark
          @click="downExcel()"
          :disabled="disabledBtnDownload"
          class="btnDisabled"
        >
          <strong style="fond-size: 16px; color: #000">Descargar a Excel</strong>
        </v-btn>
      </div>
    </div>

    <v-dialog v-model="dlgMensaje" persistent max-width="600px">
      <v-card>
        <div class="gris">
          <v-card-title class="headline">
            <div class="titModal">
              <div>
                <strong>{{ titMensaje }}</strong>
              </div>
            </div>
          </v-card-title>
          <div class="contModal tCenter">
            <div class="pre-formatted">{{ txtMensaje }}</div>
          </div>
          <br />
          <div class="tCenter">
            <v-btn color="primary" dark @click="dlgMensaje = false">
              <strong style="fond-size: 16px; color: #000">OK</strong>
            </v-btn>
          </div>
        </div>
      </v-card>
    </v-dialog>
  </div>
</template>

<script>
import FileSaver from "file-saver";
import store from "@/store";
import axios from "axios";
const serviceCommons = store.state.serviceCommons;

import moment from "moment";

export default {
  name: "supervision_mantenimiento_asistencia_mantenimiento_director",

  data() {
    return {
      minsPersisteLocalStorage: 30,
      idUsuario: "",
      lblUsuario: "Lista",
      lblSearchCuatrimestre: "Selecciona los datos para La búsqueda",
      //calendario
      disabledDate: false,

      menu: false,
      modal: false,
      menu1: false,
      menu2: false,
      date: "",
      date1: "",
      dateFormatted: "",
      dateFormatted2: "",

      //  Params para regresar a Segundo Nivel
      paramsNivel_2: "",
      fechaInicio: "",
      fechaFin: "",
      idTerritorio: "",
      territorio: "",
      responsable: "",
      valueTrimestre: "",
      targetTrimestre: "",
      valueAldia: "",
      targetAldia: "",
      rangoSemanas: "",
      rangos: "",
      colores: "",

      //dialogs
      disabledBtnBuscar: true,
      disabledBtnDownload: true,
      mdlBtnBuscar: true,
      //   DIALOGS
      dlgMensaje: false,
      titMensaje: "",
      txtMensaje: "",
      idLocStorage: "",
      //pagina
      ruta: "https://www.hotmail/",
      pageCount: 1,
      page: 1,
      itemsPerPage: 20,
      search: "",
      propiedades_footer: {
        itemsPerPageOptions: [2, 4, 5, 10],
        //habilita botones
        habilitaFechaFin: true,
      },
      encabezadoAsignacion: [
        { text: "No.Usuario", value: "idUsuario", align: "center" },
        { text: "Nombre", value: "nombreUsuario", align: "center" },
        { text: "Fecha", value: "fecha", align: "center" },
        { text: "Semana", value: "semana", align: "center" },
        { text: "Dia", value: "dia", align: "center" },
        { text: "Hora Entrada", value: "horaEntrada", align: "center" },
        { text: "Hora Salida", value: "horaSalida", align: "center" },
        { text: "Horas Trabajadas", value: "horasTrabajadas", align: "center" },
        {
          text: "Sucursales Realizadas",
          value: "totalVisitas",
          align: "center",
        },
        //{ text: "Módulos Contestados", value: "totalModulos", align: "center" },
        { text: "Detalle", value: "lnkDetalle_", align: "center" },
      ],
      asignaciones: [],
      metadata: {
        usuarios: [],
      },
      breadcrumbs: [
        {
          text: "Plataforma de Franquicia",
          disabled: false,
          exact: true,
          to: {
            name: "home",
          },
        },
        {
          text: "Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_asignaciones_home",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento",
          disabled: false,
          exact: true,
          to: {
            name: "supervision_mantenimiento_dashboard_director",
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Regional",
          disabled: true,
        },
        {
          text: "Dashboard Supervisión Mantenimiento Territorio",
          disabled: true,
          to: {
            name: "supervision_mantenimiento_dashboard_segundo_nivel",
            params: {
              parametros: window.btoa(
                unescape(
                  encodeURIComponent(
                    JSON.stringify({
                      territorio: this.territorio,
                      idTerritorio: this.idTerritorio,
                      fechaInicio: this.fechaInicio,
                      fechaFin: this.fechaFin,
                      valueTrimestre: this.valueTrimestre,
                      targetTrimestre: this.targetTrimestre,
                      valueAldia: this.valueAldia,
                      targetAldia: this.targetAldia,
                      rangoSemanas: this.rangoSemanas,
                      rangos: this.rangos,
                    })
                  )
                )
              ),
            },
          },
        },
        {
          text: "Dashboard Supervisión Mantenimiento Supervisor",
          disabled: true,
        },
        {
          text: "Detalle Semana Supervisor",
          disabled: true,
        },
      ],
    };
  },
  beforeCreate() {
    let parametros = JSON.parse(
      decodeURIComponent(escape(window.atob(this.$route.query.parametros)))
    );
    this.paramsNivel_2 = parametros.paramsNivel_2;
    console.log("BEFORE CREATE LISTA:" + this.paramsNivel_2);

    if (this.paramsNivel_2) {
      let parmsJson = JSON.parse(this.paramsNivel_2);
      console.log("Params Nivel 2 - rangos: " + parmsJson.rangos);

      this.fechaInicio = parmsJson.fechaInicio;
      this.fechaFin = parmsJson.fechaFin;
      this.idTerritorio = parmsJson.idTerritorio;
      this.territorio = parmsJson.territorio;
      this.responsable = parmsJson.responsable;
      this.valueTrimestre = parmsJson.valueTrimestre;
      this.targetTrimestre = parmsJson.targetTrimestre;
      this.valueAldia = parmsJson.valueAldia;
      this.targetAldia = parmsJson.targetAldia;
      this.rangoSemanas = parmsJson.rangoSemanas;
      this.rangos = parmsJson.rangos;
      this.colores = "ea5270";
    }
  },
  created() {
    this.limpiaFormulario();

    if (!this.getUrlData()) {
      this.hayStorage();
    }
  },
  methods: {
    setUrlDateX(locDate, dt) {
      console.log(locDate + " - " + dt);
      let yyyy = dt.getFullYear().toString();
      let dd = dt.getDate() > 9 ? dt.getDate().toString() : "0" + dt.getDate().toString();
      let mm =
        dt.getMonth() > 8
          ? (1 + dt.getMonth()).toString()
          : "0" + (1 + dt.getMonth()).toString();

      if (locDate == "date") this.date = yyyy + "-" + mm + "-" + dd;

      if (locDate == "date1") this.date1 = yyyy + "-" + mm + "-" + dd;
    },
    getUrlData() {
      let parametros = JSON.parse(
        decodeURIComponent(escape(window.atob(this.$route.query.parametros)))
      );
      //this.paramsNivel_2 = this.$route.query.paramsNivel_2;
      this.paramsNivel_2 = parametros.paramsNivel_2;

      let u = parametros.idUsuario;
      let nombrUsuario = parametros.name;
      let w = parametros.semana;
      let z = parametros.zona;

      let fIniCu = parametros.fIniCu;
      let fFinCu = parametros.fFinCu;

      if (
        typeof w == "undefined" ||
        typeof u == "undefined" ||
        typeof fIniCu == "undefined" ||
        typeof fFinCu == "undefined"
      ) {
        console.log(
          "No se detectó en URL semana/año/usr/zona" +
            "|s:" +
            w +
            "|u:" +
            u +
            "|fIni:" +
            fIniCu +
            "|z:" +
            z
        );
        return false;
      }

      let y = fIniCu.substring(4, 8);
      let fecha = this.getDateOfWeek(w, y);

      this.setUrlDateX("date", fecha.dateFrom);
      this.setUrlDateX("date1", fecha.dateTo);

      this.mdlBtnBuscar = false;
      this.disabledDate = true;

      console.log("URL info:" + this.date + " / " + this.date1 + " |u:" + u + " |z:" + z);
      localStorage.removeItem("LS_Supervs");
      localStorage.removeItem("fechaIniLS");
      localStorage.removeItem("fechaFinLS");
      this.lblUsuario = nombrUsuario;
      this.lblSearchCuatrimestre = "Trimestre:";

      this.getReporte1(u, z);
    },
    getDateOfWeek(week, y) {
      var d = new Date("Jan 01, " + y + " 01:00:00");
      var dayMs = 24 * 60 * 60 * 1000;
      var offSetTimeStart = dayMs * (d.getDay() - 1);
      //var w = d.getTime() + 604800000 * (week - 1) - offSetTimeStart; //reducing the offset here
      var w = d.getTime() + 604800000 * week - offSetTimeStart; //reducing the offset here
      var n1 = new Date(w);
      var n2 = new Date(w + 518400000);
      return {
        dateFrom: n1,
        dateTo: n2,
      };
    },
    verifDates() {
      const [yrI, mesI, diaI] = this.date.split("-");
      const [yrF, mesF, diaF] = this.date1.split("-");

      var dtIni = new Date(yrI, mesI - 1, diaI);
      var dtFin = new Date(yrF, mesF - 1, diaF);

      if (dtFin < dtIni) {
        this.alerta(
          "Error en Fechas",
          "La fecha fin no puede ser menor a la fecha de inicio"
        );
        return false;
      }

      return true; // Fechas OK
    },
    formateaFecha(cad) {
      return moment(String(cad)).format("DDMMYY");
    },
    hayStorage() {
      let listaSupervs = JSON.parse(localStorage.getItem("LS_Supervs"));
      let dtLastStorage = localStorage.getItem("dtLastStorage");

      if (listaSupervs != null && dtLastStorage != null) {
        var ticksDiff = Math.abs(new Date() - new Date(dtLastStorage));
        var minutes = Math.floor(ticksDiff / 1000 / 60);

        console.log(
          "Storeage detectado:" +
            dtLastStorage +
            " | mins transcurridos:" +
            minutes +
            " de:" +
            this.minsPersisteLocalStorage
        );

        if (minutes < this.minsPersisteLocalStorage) {
          this.asignaciones = listaSupervs;
          this.date = localStorage.getItem("fechaIniLS");
          this.date1 = localStorage.getItem("fechaFinLS");
          this.disabledBtnDownload = false;
          this.disabledBtnBuscar = false;
          this.alerta("Mostrando Almacenado Local");
        }
      }
    },
    getReporte1(u, z) {
      if (this.verifDates()) {
        let fechaInicio_ = moment(String(this.date)).format("DDMMYY");
        let fechaFin_ = moment(String(this.date1)).format("DDMMYY");
        let idUsuario_ = typeof u != "undefined" ? u : this.idUsuario;
        let zona_ = typeof z != "undefined" ? z : null;

        this.objAdd = {
          fechaInicio: fechaInicio_,
          fechaFin: fechaFin_,
          idUsuario: idUsuario_,
          zona: zona_,
          //zona: null,
        };

        console.log(
          "Consume[obtieneReporteAsistenciaMtto]:" +
            fechaInicio_ +
            "|" +
            fechaFin_ +
            "|u:" +
            idUsuario_ +
            "|z:" +
            zona_
        );
        //  En servicio fecha es: ddmmyy
        axios
          .post("/asignacion-mtto/secure/post/obtieneReporteAsistenciaMtto", this.objAdd)
          .then((response) => {
            if (response) {
              if (response.status === 200) {
                this.asignaciones = response.data.data;
                console.log("Supervisiones: " + JSON.stringify(this.asignaciones));

                if ("undefined" == typeof response.data.data) {
                  this.alerta(
                    "Sin Datos del servicio obtieneReporteAsistenciaMtto",
                    "Id Usuario:\t" +
                      idUsuario_ +
                      //'\n Fecha Inicio:\t' + fechaInicio_.substring(0, 2) + '/' + fechaInicio_.substring(2, 4) + '/20' + fechaInicio_.substring(4, 8) +
                      "\n fechaInicio:\t" +
                      fechaInicio_ +
                      "\n fechaFin:\t" +
                      fechaFin_ +
                      "\n zona:\t" +
                      zona_
                  );
                  return;
                }

                this.limpiaFormulario();
                this.disabledBtnDownload = false;
                this.disabledBtnBuscar = true;

                //      TEMPORAL
                //this.filtraVisitasZero()

                localStorage.setItem("LS_Supervs", JSON.stringify(this.asignaciones));
                localStorage.setItem("fechaIniLS", this.date);
                localStorage.setItem("fechaFinLS", this.date1);
                localStorage.setItem("dtLastStorage", new Date());
                console.log("Storage Set: " + new Date());
              } else {
                this.alerta("Fechas Nulas", "Fechas Nulas");
                //this.dialogFechasNulas = true;
              }
            }
          })
          .catch((error) => {
            console.log(error);
          })
          .finally(function () {});
      }
    },
    filtraVisitasZero() {
      this.asignaciones = this.asignaciones.filter(function (el) {
        return el.totalVisitas > 0;
      });

      console.log("SUPERVISIONES FILTRADAS:\n" + JSON.stringify(this.asignaciones));
    },
    crearInfoExcel() {
      let datos = this.asignaciones;
      let xlsInfo = [];
      let fields = [
        //  0-Header Excel    1-Dato desde DB
        ["NoUsuario", "idUsuario"],
        ["Nombre", "nombreUsuario"],
        ["Fecha", "fecha"],
        ["Semana", "semana"],
        ["Día", "dia"],
        ["Hora_Entrada", "horaEntrada"],
        ["Hora_Salida", "horaSalida"],
        ["Horas_Trabajadas", "horasTrabajadas"],
        ["observaciones_Entrada", "observacionesEntrada"],
        ["Tareas_Realizadas", "totalVisitas"],
        ["Módulos_Contestados", "totalModulos"],
      ];
      for (var i = 0; i < this.asignaciones.length; i++) {
        let ass = new Object();
        for (var j = 0; j < fields.length; j++) {
          let instrucc =
            "ass." +
            fields[j][0] +
            " = typeof(datos[i]." +
            fields[j][1] +
            ") == 'undefined' ? '' : " +
            "datos[i]." +
            fields[j][1];
          eval(instrucc);
          //console.log(instrucc)
        }
        xlsInfo.push(ass);
      }
      return xlsInfo;
    },
    downExcel() {
      const dataFinal = this.crearInfoExcel();
      console.log("Rows xls:" + dataFinal.length);
      //const dataFinal = this.asignaciones;
      axios({
        method: "post",
        url: "/json/convert/secure/array/excel",
        responseType: "blob",
        data: dataFinal,
      })
        .then((response) => {
          //console.log("La data:" + response.data)

          if (response.headers["content-type"] !== "application/json") {
            FileSaver.saveAs(response.data, response.headers["file-name"]);
          }
        })
        .catch((error) => {
          console.log(error);
        })
        .finally(function () {});
    },
    limpiaFormulario() {
      this.usuarioEncontrado = "";
      this.cecoSeleccionado = "";
      this.listaTipoNego = "";
      this.metadata.cecos = [];
      this.metadata.negocios = [];
      this.metadata.usuarios = [];
      this.metadata.gerentes = [];
      this.dateFormatted = "";
      this.picker = "";
      this.comentario = "";
      this.dialogConfimacionActualiza = false;
    },
    formatDate(date) {
      if (!date) return null;

      const [year, month, day] = date.split("-");
      return `${month}/${day}/${year}`;
    },
    parseDate(date) {
      if (!date) return null;

      const [month, day, year] = date.split("/");
      return `${year}-${month.padStart(2, "0")}-${day.padStart(2, "0")}`;
    },
    chgDate() {
      if (this.date.length > 8 && this.date1.length > 8) this.disabledBtnBuscar = false;
    },
    alerta(titulo, mensaje) {
      this.titMensaje = titulo;
      this.txtMensaje = mensaje;
      this.dlgMensaje = true;
    },
    getLinkToDetalle(item) {
      //console.log('Getin Link to Detalle:' + this.paramsNivel_2)
      let parametros = {
        fechaSQ: item.fecha,
        idUsuario: item.idUsuario,
        nombreUsuario: item.nombreUsuario,
        semana: item.semana,
        paramsNivel_2: this.paramsNivel_2,
      };
      let liga =
        "/supervision-mantenimiento/dashboard/supervision_semanal_detalle/director?parametros=" +
        this.serviceCommons.objectToBase64(parametros);
      return liga;
    },
  }, // fin metodos
  computed: {
    computedDateFormatted() {
      return this.formatDate(this.date);
    },
    serviceCommons() {
      return serviceCommons;
    },
  },
  watch: {
    date(val) {
      this.dateFormatted = this.formatDate(this.date);
    },
    date2(val) {
      this.dateFormatted2 = this.formatDate(this.date);
    },
  },
};
</script>

<style>
.padding {
  padding-bottom: 25px;
}
.btnDisabled {
  color: gray;
  border: 1px solid #f7b851;
}
.rojo {
  color: red;
}
.verde {
  color: greenyellow;
}
.pre-formatted {
  white-space: pre;
}
</style>
